Index: /branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- /branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 4063)
+++ /branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 4064)
@@ -1440,149 +1776,110 @@
 
       !!  Arguments
-      CHARACTER(len=1),                 INTENT(in) :: cd_type      ! grid type T, W ( U, V, F)
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) :: p_mask       ! Parent grid T mask
-      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(in), OPTIONAL :: p_e1, p_e2         ! 3D tracer T or W on parent grid
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in), OPTIONAL :: p_e3         ! 3D tracer T or W on parent grid
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out):: p_surf_crs ! Coarse grid box east or north face quantity 
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out):: p_surf_crs_msk ! Coarse grid box east or north face quantity 
+      CHARACTER(len=1),                         INTENT(in)           :: cd_type      ! grid type T, W ( U, V, F)
+      REAL(wp), DIMENSION(jpi,jpj,jpk)        , INTENT(in)           :: p_mask       ! Parent grid T mask
+      REAL(wp), DIMENSION(jpi,jpj)            , INTENT(in), OPTIONAL :: p_e1, p_e2         ! 3D tracer T or W on parent grid
+      REAL(wp), DIMENSION(jpi,jpj,jpk)        , INTENT(in), OPTIONAL :: p_e3         ! 3D tracer T or W on parent grid
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out)          :: p_surf_crs ! Coarse grid box east or north face quantity 
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out)          :: p_surf_crs_msk ! Coarse grid box east or north face quantity 
 
       !! Local variables
       INTEGER  :: ji, jj, jk                   ! dummy loop indices
-      INTEGER  :: ijie, ijje, ii, ij
-      REAL(wp), DIMENSION(:,:)  , POINTER :: zsurf   
-      REAL(wp), DIMENSION(:,:,:), POINTER :: zsurf3d   
-      REAL(wp) :: zsfcrs, zsfcrs_msk
+      INTEGER  :: ii, ij, je_2
+      REAL(wp), DIMENSION(:,:,:), POINTER :: zsurf, zsurfmsk   
       !!----------------------------------------------------------------  
       ! Initialize
 
 
+      CALL wrk_alloc( jpi, jpj, jpk, zsurf, zsurfmsk )
       !
       SELECT CASE ( cd_type )
       
-         CASE ('W')
-      
-           CALL wrk_alloc( jpi, jpj, zsurf )
-           zsurf(:,:) =  p_e1(:,:) * p_e2(:,:)
-        
-            DO ji = nistr, niend, nn_factx
-               DO jj   = njstr, njend, nn_facty
-                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                  ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                  ijje = mje_crs(ij)
-                  ijie = mie_crs(ii)
+         CASE ('W')    
+            DO jk = 1, jpk
+               zsurf(:,:,jk) = p_e1(:,:) * p_e2(:,:) 
+            ENDDO
+            zsurfmsk(:,:,1) = zsurf(:,:,1) * p_mask(:,:,1) 
+            DO jk = 2, jpk
+               zsurfmsk(:,:,jk) = zsurf(:,:,jk) * p_mask(:,:,jk-1) 
+            ENDDO
+
+         CASE ('V')     
+            DO jk = 1, jpk
+               zsurf(:,:,jk) = p_e1(:,:) * p_e3(:,:,jk) 
+            ENDDO
+            DO jk = 1, jpk
+               zsurfmsk(:,:,jk) = zsurf(:,:,jk) * p_mask(:,:,jk) 
+            ENDDO
+
+         CASE ('U')     
+            DO jk = 1, jpk
+               zsurf(:,:,jk) = p_e2(:,:) * p_e3(:,:,jk) 
+            ENDDO
+            DO jk = 1, jpk
+               zsurfmsk(:,:,jk) = zsurf(:,:,jk) * p_mask(:,:,jk) 
+            ENDDO
+
+         CASE DEFAULT
+            DO jk = 1, jpk
+               zsurf(:,:,jk) = p_e1(:,:) * p_e2(:,:) 
+            ENDDO
+            DO jk = 1, jpk
+               zsurfmsk(:,:,jk) = zsurf(:,:,jk) * p_mask(:,:,jk) 
+            ENDDO
+      END SELECT
+
+      IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+         IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+            je_2 = mje_crs(2)
+            DO jk = 1, jpk
+               DO ji = nistr, niend, nn_factx
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2 
+                  !    
+                  p_surf_crs    (ii,2,jk) =  zsurf(ji,je_2  ,jk) + zsurf(ji+1,je_2  ,jk) + zsurf(ji+2,je_2  ,jk) &
+                    &                      + zsurf(ji,je_2-1,jk) + zsurf(ji+1,je_2-1,jk) + zsurf(ji+2,je_2-1,jk)  ! Why ?????
                   !
-                  zsfcrs     =  zsurf(ji,jj  ) + zsurf(ji+1,jj  ) + zsurf(ji+2,jj  )  &
-                    &         + zsurf(ji,jj+1) + zsurf(ji+1,jj+1) + zsurf(ji+2,jj+1)  &
-                    &         + zsurf(ji,jj+2) + zsurf(ji+1,jj+2) + zsurf(ji+2,jj+2)  
-                  !
-                  zsfcrs_msk =  zsurf(ji  ,jj  ) * p_mask(ji  ,jj  ,1)  &
-                    &         + zsurf(ji+1,jj  ) * p_mask(ji+1,jj  ,1)  &
-                    &         + zsurf(ji+2,jj  ) * p_mask(ji+2,jj  ,1)  &
-                    &         + zsurf(ji  ,jj+1) * p_mask(ji  ,jj+1,1)  &
-                    &         + zsurf(ji+1,jj+1) * p_mask(ji+1,jj+1,1)  &
-                    &         + zsurf(ji+2,jj+1) * p_mask(ji+2,jj+1,1)  &
-                    &         + zsurf(ji  ,jj+2) * p_mask(ji  ,jj+2,1)  &
-                    &         + zsurf(ji+1,jj+2) * p_mask(ji+1,jj+2,1)  &
-                    &         + zsurf(ji+2,jj+2) * p_mask(ji+2,jj+2,1)
-                  !
-                  p_surf_crs    (ii,ij,1) = zsfcrs
-                  p_surf_crs_msk(ii,ij,1) = zsfcrs_msk
+                  p_surf_crs_msk(ii,2,jk) =  zsurfmsk(ji,je_2,jk) + zsurfmsk(ji+1,je_2,jk) + zsurfmsk(ji+2,je_2,jk) 
                   !
                ENDDO
             ENDDO
-            DO jk = 2, jpk
+         ENDIF
+      ELSE
+         je_2 = mjs_crs(2)
+         DO jk = 1, jpk
+            DO ji = nistr, niend, nn_factx
+               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2 
+               !  
+               p_surf_crs    (ii,2,jk) =  zsurf(ji,je_2  ,jk) + zsurf(ji+1,je_2  ,jk) + zsurf(ji+2,je_2  ,jk)  &
+                    &                   + zsurf(ji,je_2+1,jk) + zsurf(ji+1,je_2+1,jk) + zsurf(ji+2,je_2+1,jk)  &
+                    &                   + zsurf(ji,je_2+2,jk) + zsurf(ji+1,je_2+2,jk) + zsurf(ji+2,je_2+2,jk)  
+
+               p_surf_crs_msk(ii,2,jk) =  zsurfmsk(ji,je_2  ,jk) + zsurfmsk(ji+1,je_2  ,jk) + zsurfmsk(ji+2,je_2  ,jk)  &
+                    &                   + zsurfmsk(ji,je_2+1,jk) + zsurfmsk(ji+1,je_2+1,jk) + zsurfmsk(ji+2,je_2+1,jk)  &
+                    &                   + zsurfmsk(ji,je_2+2,jk) + zsurfmsk(ji+1,je_2+2,jk) + zsurfmsk(ji+2,je_2+2,jk)  
+                ENDDO
+            ENDDO
+      ENDIF
+         
+      DO jk = 1, jpk
+         DO jj = njstr, njend, nn_facty
+            DO ji = nistr, niend, nn_factx
+               ii = ( ji - mis_crs(2) ) * rfactx_r + 2  
+               ij = ( jj - njstr ) * rfacty_r + 3
                !
-               p_surf_crs(:,:,jk) = p_surf_crs(:,:,1)
-               !
-               DO ji = nistr, niend, nn_factx
-                  DO jj   = njstr, njend, nn_facty
-                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                     ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                     ijje = mje_crs(ij)
-                     ijie = mie_crs(ii)
-                     !
-                     zsfcrs_msk =  zsurf(ji  ,jj  ) * p_mask(ji  ,jj  ,jk-1)  &
-                       &         + zsurf(ji+1,jj  ) * p_mask(ji+1,jj  ,jk-1)  &
-                       &         + zsurf(ji+2,jj  ) * p_mask(ji+2,jj  ,jk-1)  &
-                       &         + zsurf(ji  ,jj+1) * p_mask(ji  ,jj+1,jk-1)  &
-                       &         + zsurf(ji+1,jj+1) * p_mask(ji+1,jj+1,jk-1)  &
-                       &         + zsurf(ji+2,jj+1) * p_mask(ji+2,jj+1,jk-1)  &
-                       &         + zsurf(ji  ,jj+2) * p_mask(ji  ,jj+2,jk-1)  &
-                       &         + zsurf(ji+1,jj+2) * p_mask(ji+1,jj+2,jk-1)  &
-                       &         + zsurf(ji+2,jj+2) * p_mask(ji+2,jj+2,jk-1)
-                       !
-                       p_surf_crs_msk(ii,ij,jk) = zsfcrs_msk
-                       !
-                   ENDDO
-                ENDDO
-            ENDDO
-                        
-            CALL wrk_dealloc( jpi, jpj, zsurf )
-          
-         CASE( 'V' )
-           
-           CALL wrk_alloc( jpi, jpj, jpk, zsurf3d )
-           DO jk = 1, jpk
-              zsurf3d(:,:,jk) =  p_e1(:,:) * p_e3(:,:,jk)
-           ENDDO
-         
-           DO jk = 1, jpk
-              DO ji = nistr, niend, nn_factx
-                 DO jj = njstr, njend, nn_facty
-                    ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                    ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                    ijje = mje_crs(ij)
-                    ijie = mie_crs(ii)
-                    !                  
-                    zsfcrs      =  zsurf3d(ji,ijje,jk) + zsurf3d(ji+1,ijje,jk) + zsurf3d(ji+2,ijje,jk)
-                    !
-                    zsfcrs_msk  =  zsurf3d(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk) &
-                      &          + zsurf3d(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk) &
-                      &          + zsurf3d(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) 
-                    !
-                    p_surf_crs    (ii,ij,jk) = zsfcrs
-                    p_surf_crs_msk(ii,ij,jk) = zsfcrs_msk
-                    !
-                  ENDDO      
-              ENDDO
-           ENDDO   
-
-           CALL wrk_dealloc( jpi, jpj, jpk, zsurf3d )
-            
-         CASE( 'U' )
-         
-           CALL wrk_alloc( jpi, jpj, jpk, zsurf3d )
-           DO jk = 1, jpk
-              zsurf3d(:,:,jk) =  p_e2(:,:) * p_e3(:,:,jk)
-           ENDDO
-         
-           DO jk = 1, jpk
-              DO ji = nistr, niend, nn_factx
-                 DO jj = njstr, njend, nn_facty
-                    ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                    ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                    ijje = mje_crs(ij)
-                    ijie = mie_crs(ii)
-                    !                  
-                    zsfcrs      =  zsurf3d(ijie,jj,jk) + zsurf3d(ijie,jj+1,jk) + zsurf3d(ijie,jj+2,jk)
-                    !
-                    zsfcrs_msk  =  zsurf3d(ijie  ,jj,jk) * p_mask(ijie,jj  ,jk) &
-                      &          + zsurf3d(ijie,jj+1,jk) * p_mask(ijie,jj+1,jk) &
-                      &          + zsurf3d(ijie,jj+2,jk) * p_mask(ijie,jj+2,jk) 
-                    !
-                    p_surf_crs    (ii,ij,jk) = zsfcrs
-                    p_surf_crs_msk(ii,ij,jk) = zsfcrs_msk
-                    !
-                  ENDDO      
-              ENDDO
-           ENDDO  
- 
-           CALL wrk_dealloc( jpi, jpj, jpk, zsurf3d )
-
-      END SELECT
-      
+               p_surf_crs    (ii,ij,jk) =  zsurf(ji,jj  ,jk) + zsurf(ji+1,jj  ,jk) + zsurf(ji+2,jj  ,jk)  &
+                    &                    + zsurf(ji,jj+1,jk) + zsurf(ji+1,jj+1,jk) + zsurf(ji+2,jj+1,jk)  &
+                    &                    + zsurf(ji,jj+2,jk) + zsurf(ji+1,jj+2,jk) + zsurf(ji+2,jj+2,jk)  
+
+               p_surf_crs_msk(ii,ij,jk) =  zsurfmsk(ji,jj  ,jk) + zsurfmsk(ji+1,jj  ,jk) + zsurfmsk(ji+2,jj  ,jk)  &
+                    &                    + zsurfmsk(ji,jj+1,jk) + zsurfmsk(ji+1,jj+1,jk) + zsurfmsk(ji+2,jj+1,jk)  &
+                    &                    + zsurfmsk(ji,jj+2,jk) + zsurfmsk(ji+1,jj+2,jk) + zsurfmsk(ji+2,jj+2,jk)  
+            ENDDO      
+         ENDDO
+      ENDDO   
+
       CALL crs_lbc_lnk( p_surf_crs    , cd_type, 1.0, pval=1.0 )
       CALL crs_lbc_lnk( p_surf_crs_msk, cd_type, 1.0, pval=1.0 )
 
+      CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zsurfmsk )
 
    END SUBROUTINE crs_dom_sfc
@@ -1601,14 +1898,18 @@
       INTEGER  :: ji,jj,jk,ijjgloT,ijis,ijie,ijjs,ijje,jn      ! dummy indices
       INTEGER  :: ierr                                ! allocation error status
-   
-     ! 1.a. Define global domain indices
+ 
+  
+     ! 1.a. Define global domain indices  : take into account the interior domain only ( removes i/j=1 , i/j=jpiglo/jpjglo ) then add 2/3 grid points 
       jpiglo_crs   = INT( (jpiglo - 2) / nn_factx ) + 2
-      jpjglo_crs   = INT( (jpjglo - 2) / nn_facty ) + 2  ! the -2 removes j=1, j=jpj
+  !    jpjglo_crs   = INT( (jpjglo - 2) / nn_facty ) + 2  ! the -2 removes j=1, j=jpj
+  !    jpjglo_crs   = INT( (jpjglo - 2) / nn_facty ) + 3
+      jpjglo_crs   = INT( (jpjglo - MOD(jpjglo, nn_facty)) / nn_facty ) + 3
       jpiglo_crsm1 = jpiglo_crs - 1
       jpjglo_crsm1 = jpjglo_crs - 1  
 
-     ! 1.b. Define local domain indices
-      jpi_crs = ( jpiglo_crs-2 * jpreci + (jpni-1) ) / jpni + 2*jpreci
-      jpj_crs = ( jpjglo_crs-2 * jprecj + (jpnj-1) ) / jpnj + 2*jprecj
+      jpi_crs = ( jpiglo_crs   - 2 * jpreci + (jpni-1) ) / jpni + 2 * jpreci
+      jpj_crs = ( jpjglo_crsm1 - 2 * jprecj + (jpnj-1) ) / jpnj + 2 * jprecj   
+              
+      IF( noso < 0 ) jpj_crs = jpj_crs + 1    ! add a local band on southern processors  
        
       jpi_crsm1   = jpi_crs - 1
@@ -1618,5 +1919,6 @@
       
       ierr = crs_dom_alloc()          ! allocate most coarse grid arrays
-     ! 2.a Define processor domain
+
+      ! 2.a Define processor domain
       IF( .NOT. lk_mpp ) THEN
          nimpp_crs  = 1
@@ -1628,5 +1930,4 @@
          nlei_crs   = jpi_crs
          nlej_crs   = jpj_crs
-
       ELSE
          ! Initialisation of most local variables -
@@ -1642,5 +1943,5 @@
         ! Calculs suivant une découpage en j
         DO jn = 1, jpnij, jpni
-           IF( jn < (jpnij-jpni + 1)) THEN
+           IF( jn < ( jpnij - jpni + 1 ) ) THEN
               nlejt_crs(jn) = AINT( REAL( ( jpjglo - (njmppt(jn     ) - 1) ) / nn_facty, wp ) ) &
                        &    - AINT( REAL( ( jpjglo - (njmppt(jn+jpni) - 1) ) / nn_facty, wp ) )
@@ -1648,8 +1949,8 @@
               nlejt_crs(jn) = AINT( REAL(  nlejt(jn) / nn_facty, wp ) ) + 1            
            ENDIF
-           
+           IF( noso < 0 ) nlejt_crs(jn) = nlejt_crs(jn) + 1             
            SELECT CASE( ibonjt(jn) )
               CASE ( -1 )
-                IF( MOD( jpjglo - njmppt(jn), nn_facty) > 0 )    nlejt_crs(jn) = nlejt_crs(jn) + 1
+                IF( MOD( jpjglo - njmppt(jn), nn_facty) > 0 )  nlejt_crs(jn) = nlejt_crs(jn) + 1
                 nlcjt_crs(jn) = nlejt_crs(jn) + jprecj
                 nldjt_crs(jn) = nldjt(jn)
@@ -1657,7 +1958,8 @@
               CASE ( 0 )
               
+                nldjt_crs(jn) = nldjt(jn)
+                IF( nldjt(jn) == 1 )  nlejt_crs(jn) = nlejt_crs(jn) + 1
                 nlejt_crs(jn) = nlejt_crs(jn) + jprecj
                 nlcjt_crs(jn) = nlejt_crs(jn) + jprecj
-                nldjt_crs(jn) = nldjt(jn)
                 
               CASE ( 1, 2 )
@@ -1670,6 +1972,11 @@
                  STOP
            END SELECT
-         
-           njmppt_crs(jn) = ANINT(REAL((njmppt(jn) + 1 + MOD( jpjglo - njmppt(jn) + 1, nn_facty )) / nn_facty, wp ) )
+           IF( nlcjt_crs(jn) > jpj_crs )     jpj_crs = jpj_crs + 1
+
+           IF(nldjt_crs(jn) == 1 ) THEN
+              njmppt_crs(jn) = 1
+           ELSE
+              njmppt_crs(jn) = 2 + ANINT(REAL((njmppt(jn) + 1 - MOD( jpjglo , nn_facty )) / nn_facty, wp ) )
+           ENDIF           
            
            DO jj = jn + 1, jn + jpni - 1
@@ -1685,43 +1992,42 @@
         njmpp_crs = njmppt_crs(nproc + 1)
 
-         !!!! Calcul suivant un decoupage en i
-           DO jn = 1, jpni
-              IF( jn < jpni ) THEN
-         
-                 nleit_crs(jn) = AINT( REAL( ( jpiglo - (nimppt(jn  ) - 1) ) / nn_factx, wp ) ) &
-                         &     - AINT( REAL( ( jpiglo - (nimppt(jn+1) - 1) ) / nn_factx, wp ) )
-              ELSE
-                 nleit_crs(jn) = AINT( REAL( ( jpiglo - (nimppt(jn  ) - 1) ) / nn_factx, wp ) )
-              ENDIF
-              SELECT CASE( ibonit(jn) )
-           
-                 CASE ( -1 )
-                   nleit_crs(jn) = nleit_crs(jn) + jpreci           
-                   nlcit_crs(jn) = nleit_crs(jn) + jpreci
-                   nldit_crs(jn) = nldit(jn) 
+        ! Calcul suivant un decoupage en i
+        DO jn = 1, jpni
+           IF( jn == 1 ) THEN          
+              nleit_crs(jn) = AINT( REAL( ( nimppt(jn  ) - 1 + nlcit(jn  ) )  / nn_factx, wp) )
+           ELSE
+              nleit_crs(jn) = AINT( REAL( ( nimppt(jn  ) - 1 + nlcit(jn  ) )  / nn_factx, wp) ) &
+                 &          - AINT( REAL( ( nimppt(jn-1) - 1 + nlcit(jn-1) )  / nn_factx, wp) )
+           ENDIF
+
+           SELECT CASE( ibonit(jn) )
+              CASE ( -1 )
+                 nleit_crs(jn) = nleit_crs(jn) + jpreci           
+                 nlcit_crs(jn) = nleit_crs(jn) + jpreci
+                 nldit_crs(jn) = nldit(jn) 
               
-                 CASE ( 0 )
-                   nleit_crs(jn) = nleit_crs(jn) + jpreci
-                   nlcit_crs(jn) = nleit_crs(jn) + jpreci
-                   nldit_crs(jn) = nldit(jn) 
+              CASE ( 0 )
+                 nleit_crs(jn) = nleit_crs(jn) + jpreci
+                 nlcit_crs(jn) = nleit_crs(jn) + jpreci
+                 nldit_crs(jn) = nldit(jn) 
                 
-                 CASE ( 1, 2 )
-                   IF( MOD( jpiglo - nimppt(jn), nn_factx) > 0 )    nleit_crs(jn) = nleit_crs(jn) + 1
-                   nleit_crs(jn) = nleit_crs(jn) + jpreci
-                   nlcit_crs(jn) = nleit_crs(jn)
-                   nldit_crs(jn) = nldit(jn) 
-                
-                 CASE DEFAULT
-                    STOP
-              END SELECT
-
-              nimppt_crs(jn) =ANINT( REAL( (nimppt(jn) + 1 ) / nn_factx, wp ) ) + 1
-              DO jj = jn+jpni , jpnij, jpni
-                 nleit_crs(jj) = nleit_crs(jn) 
-                 nlcit_crs(jj) = nlcit_crs(jn)
-                 nldit_crs(jj) = nldit_crs(jn)
-                 nimppt_crs(jj)= nimppt_crs(jn)
-              ENDDO
-           ENDDO 
+              CASE ( 1, 2 )
+                 IF( MOD( jpiglo - nimppt(jn), nn_factx) > 0 )  nleit_crs(jn) = nleit_crs(jn) + 1
+                 nleit_crs(jn) = nleit_crs(jn) + jpreci
+                 nlcit_crs(jn) = nleit_crs(jn)
+                 nldit_crs(jn) = nldit(jn) 
+
+              CASE DEFAULT
+                 STOP
+           END SELECT
+
+           nimppt_crs(jn) = ANINT( REAL( (nimppt(jn) + 1 ) / nn_factx, wp ) ) + 1
+           DO jj = jn + jpni , jpnij, jpni
+              nleit_crs(jj) = nleit_crs(jn) 
+              nlcit_crs(jj) = nlcit_crs(jn)
+              nldit_crs(jj) = nldit_crs(jn)
+              nimppt_crs(jj)= nimppt_crs(jn)
+           ENDDO
+         ENDDO 
         
          nlei_crs  = nleit_crs(nproc + 1) 
@@ -1730,6 +2036,7 @@
          nimpp_crs = nimppt_crs(nproc + 1)
 
-         ! rajouter la condition stop
+         ! No coarsening with zoom
          IF( jpizoom /= 1 .OR. jpjzoom /= 1)    STOP 
+
          DO ji = 1, jpi_crs
             mig_crs(ji) = ji + nimpp_crs - 1
@@ -1737,4 +2044,14 @@
          DO jj = 1, jpj_crs
             mjg_crs(jj) = jj + njmpp_crs - 1!
+         ENDDO
+       
+         DO ji = 1, jpiglo_crs
+            mi0_crs(ji) = MAX( 1, MIN( ji - nimpp_crs + 1 , jpi_crs + 1 ) )
+            mi1_crs(ji) = MAX( 0, MIN( ji - nimpp_crs + 1 , jpi_crs     ) )
+         ENDDO
+         
+         DO jj = 1, jpjglo_crs
+            mj0_crs(jj) = MAX( 1, MIN( jj - njmpp_crs + 1 , jpj_crs + 1 ) )
+            mj1_crs(jj) = MAX( 0, MIN( jj - njmpp_crs + 1 , jpj_crs     ) )
          ENDDO
 
@@ -1773,5 +2090,5 @@
      
 
-      IF (lwp) THEN
+      IF(lwp) THEN
          WRITE(numout,*)
          WRITE(numout,*) 'crs_init : coarse grid dimensions'
@@ -1793,18 +2110,7 @@
          WRITE(numout,*) ' njmpp  = '     , njmpp
          WRITE(numout,*) ' njmpp_full  = ', njmpp_full
-         WRITE(numout,*) ' nreci'         , nreci 
-   !      WRITE(numout,*) ' nlejt'         , nlejt
-   !      WRITE(numout,*) ' nldjt'         , nldjt
-   !      WRITE(numout,*) ' nlcjt'         , nlcjt
-   !      WRITE(numout,*) ' njmppt'        , njmppt
-   !      WRITE(numout,*) ' nleit'         , nleit
-   !      WRITE(numout,*) ' nldit'         , nldit
-   !      WRITE(numout,*) ' nlcit'         , nlcit         
-   !      WRITE(numout,*) ' nimppt'        , nimppt
-   !      WRITE(numout,*) ' nleit_full'    , nleit_full
          WRITE(numout,*)
       ENDIF
       
-
       CALL dom_grid_glo
       
@@ -1847,10 +2153,10 @@
         
             DO ji = 2, jpiglo_crsm1
-               ijie = (ji*nn_factx)-nn_factx   !cc
-               ijis = ijie-nn_factx+1
+               ijie = ( ji * nn_factx ) - nn_factx   !cc
+               ijis = ijie - nn_factx + 1
                mis2_crs(ji) = ijis
                mie2_crs(ji) = ijie
             ENDDO
-            IF ( jpiglo - 1 - mie2_crs(jpiglo_crsm1) <= nn_factx ) mie2_crs(jpiglo_crsm1)  = jpiglo-2  
+            IF ( jpiglo - 1 - mie2_crs(jpiglo_crsm1) <= nn_factx ) mie2_crs(jpiglo_crsm1) = jpiglo - 2  
 
             ! Handle first the northernmost bin
@@ -1859,9 +2165,9 @@
             ENDIF
 
-            DO jj = 2, jpjglo_crsm1
-                ijje = ijjgloT-nn_facty*(jj-2)
-                ijjs = ijje-nn_facty+1                   
-                mjs2_crs(jpjglo_crs-jj+1) = ijjs
-                mje2_crs(jpjglo_crs-jj+1) = ijje
+            DO jj = 2, jpjglo_crs
+                ijje = ijjgloT - nn_facty * ( jj - 3 )
+                ijjs = ijje - nn_facty + 1                   
+                mjs2_crs(jpjglo_crs-jj+2) = ijjs
+                mje2_crs(jpjglo_crs-jj+2) = ijje
             ENDDO
 
@@ -1872,14 +2178,14 @@
 
             DO ji = 2, jpiglo_crsm1
-               ijie = (ji*nn_factx)-nn_factx 
-               ijis = ijie-nn_factx+1
+               ijie = ( ji * nn_factx ) - nn_factx 
+               ijis = ijie - nn_factx + 1
                mis2_crs(ji) = ijis
                mie2_crs(ji) = ijie
             ENDDO
-            IF ( jpiglo - 1 - mie2_crs(jpiglo_crsm1) <= nn_factx ) mie_crs(jpiglo_crsm1)  = jpiglo-2 
+            IF ( jpiglo - 1 - mie2_crs(jpiglo_crsm1) <= nn_factx ) mie_crs(jpiglo_crsm1)  = jpiglo - 2 
 
             ! Treat the northernmost bin separately.
             jj = 2
-            ijje = jpj-nn_facty*(jj-2)
+            ijje = jpj - nn_facty * ( jj - 2 )
             IF ( nn_facty == 3 ) THEN   ;  ijjs = ijje - 1 
             ELSE                        ;  ijjs = ijje - nn_facty + 1
@@ -1890,9 +2196,9 @@
             ! Now bin the rest, any remainder at the south is lumped in the southern bin
             DO jj = 3, jpjglo_crsm1
-                ijje = jpjglo-nn_facty*(jj-2)
-                ijjs = ijje-nn_facty+1                  
-                IF ( ijjs <= nn_facty )   ijjs = 2
-                mjs2_crs(jpj_crs-jj+1) = ijjs
-                mje2_crs(jpj_crs-jj+1) = ijje
+                ijje = jpjglo - nn_facty * ( jj - 2 )
+                ijjs = ijje - nn_facty + 1                  
+                IF ( ijjs <= nn_facty )  ijjs = 2
+                mjs2_crs(jpj_crs-jj+1)   = ijjs
+                mje2_crs(jpj_crs-jj+1)   = ijje
             ENDDO
 
@@ -1908,8 +2214,12 @@
 
      ! Pad the boundaries, do not know if it is necessary
-      mis2_crs(1) = 1             ; mis2_crs(jpiglo_crs) = mie2_crs(jpiglo_crs - 1) + 1   
-      mie2_crs(1) = nn_factx      ; mie2_crs(jpiglo_crs) = jpiglo                         
-      mje2_crs(1) = mjs2_crs(2)-1 ; mje2_crs(jpjglo_crs) = jpjglo
-      mjs2_crs(1) = 1             ; mjs2_crs(jpjglo_crs) = mje2_crs(jpjglo_crs) - nn_facty + 1 
+      mis2_crs(2) = 1             ;  mis2_crs(jpiglo_crs) = mie2_crs(jpiglo_crs - 1) + 1   
+      mie2_crs(2) = nn_factx      ;  mie2_crs(jpiglo_crs) = jpiglo                         
+      !
+      mjs2_crs(1) = 1
+      mje2_crs(1) = 1
+      !
+      mje2_crs(2) = mjs2_crs(3)-1 ;  mje2_crs(jpjglo_crs) = jpjglo
+      mjs2_crs(2) = 1             ;  mjs2_crs(jpjglo_crs) = mje2_crs(jpjglo_crs) - nn_facty + 1 
  
       IF( .NOT. lk_mpp ) THEN     
@@ -1928,6 +2238,7 @@
         ENDDO
       ENDIF
-      njstr = mjs_crs(2)  ;   njend = mjs_crs(nlcj_crs - 1)
+      !
       nistr = mis_crs(2)  ;   niend = mis_crs(nlci_crs - 1)
+      njstr = mjs_crs(3)  ;   njend = mjs_crs(nlcj_crs - 1)
       !
    END SUBROUTINE crs_dom_def
Index: /branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdomwri.F90
===================================================================
--- /branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdomwri.F90	(revision 4063)
+++ /branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdomwri.F90	(revision 4064)
@@ -211,6 +211,6 @@
             DO jj = 1,jpj_crs   
                DO ji = 1,jpi_crs
-                  ze3tp(ji,jj) = fse3t_crs(ji,jj,mbkt_crs(ji,jj)) * tmask_crs(ji,jj,1)
-                  ze3wp(ji,jj) = fse3w_crs(ji,jj,mbkt_crs(ji,jj)) * tmask_crs(ji,jj,1)
+                  ze3tp(ji,jj) = e3t_crs(ji,jj,mbkt_crs(ji,jj)) * tmask_crs(ji,jj,1)
+                  ze3wp(ji,jj) = e3w_crs(ji,jj,mbkt_crs(ji,jj)) * tmask_crs(ji,jj,1)
                END DO
             END DO
